#include "ncbind/ncbind.hpp"
#include "sqlite3.h"

//
// SQLg
// 
// cnt(a,b)    a  b ܂܂ΐ^
// ncnt(a,b)  Kꂽ a  Kꂽ b ܂܂Ăΐ^

static const tjs_char *normalizeBefore = 
L"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
L"`abcdefghijklmnopqrstuvwxy"
L""
L"PQRSTUVWXO"
L"ĂƂȂɂʂ˂"
L"͂Ђӂւق܂݂ނ߂񂟂"
L"Âłǂ΂тԂׂڂς҂Ղ؂"
L"ACEGIJLNPRTVXZ\^`cegijklm"
L"nqtwz}~@BDFHb"
L"KMOQSUWY[]_adfhorux{psvy|"
L""
L"[EAB"
L"[]{}"
L"CDFGHILMOPQZ[\]^_`"
L"befghijklmnopqrstuvwxyz{|~"
L"";

static const tjs_char *normalizeAfter = 
L"abcdefghijklmnopqrstuvwxyz"
L"abcdefghijklmnopqrstuvwxyz"
L"abcdefghijklmnopqrstuvwxyz"
L"1234567890"
L""
L"ܲݱ"
L""
L""
L"ܲݱ"
L""
L""
L"-,.-"
L"()()"
L",.:;?!'`^~_---/_-"
L"|`'\"\"()()()()()()()+-x="
L"<>\\$%#&*@*";

// 
static const tjs_char *clearChar = L"ށJK";

// Ke[u
static tjs_char normalizeData[65536];

static void
normalize(ttstr &store, const tjs_char *str)
{
	while (*str) {
		store += normalizeData[*str++];
	}
}

void
initNormalize()
{
	// Kpf[^̏
	for (int i=0;i<65536;i++) {
		normalizeData[i] = i;
	}
	const tjs_char *p = normalizeBefore;
	const tjs_char *q = normalizeAfter;
	while (*p) {
		normalizeData[*p++] = *q++;
	}
	// 
	p = clearChar;
	while (*p) {
		normalizeData[*p++] = 0;
	}
}

static void
cntFunc(sqlite3_context *context, int argc, sqlite3_value **argv)
{
	if (argc < 2) return;
	sqlite3_result_int(context, wcsstr((const tjs_char*)sqlite3_value_text16(argv[0]),
									   (const tjs_char*)sqlite3_value_text16(argv[1])) != NULL);
}

static void
ncntFunc(sqlite3_context *context, int argc, sqlite3_value **argv)
{
	if (argc < 2) return;
	ttstr a,b;
	normalize(a, (const tjs_char*)sqlite3_value_text16(argv[0]));
	normalize(b, (const tjs_char*)sqlite3_value_text16(argv[1]));
	sqlite3_result_int(context, wcsstr(a.c_str(), b.c_str()) != NULL);
}

void
initContainFunc(sqlite3 *db)
{
	// r֐̓o^
	sqlite3_create_function(db, "cnt",  2, SQLITE_ANY, NULL, cntFunc,  NULL, NULL);
	sqlite3_create_function(db, "ncnt", 2, SQLITE_ANY, NULL, ncntFunc, NULL, NULL);
}
